
//  JSON gallery browser display javascript.
//  Peter J Lawrence (December 2008)
//  Tested with coppermine and picasa JSON feeds
//  This script is based on code from  javascript by Jeroen see http://www.multiprof.nl/category/projects/pwi/

var thumbsize = 72; //size thumb /cropped(see for supported format:  http://code.google.com/apis/picasaweb/reference.html#Parameters)
var cols = 5; // distribute thumbs on albumphotos page over x collums
var maxresults = 20; //maximum of pictures on albumphotos page
var photosize = 512; //return maximum size picture (see for supported format:  http://code.google.com/apis/picasaweb/reference.html#Parameters)
var display_breadcrumbs = false;
var g_JSONFeedArray = new Array();
var scriptfolder="/modules/JSONBrowser/";

function DisplayPhoto(photo_id,htmltag,albumpage)
{
	var j = g_JSONFeedArray[htmltag];
	if (j==undefined)
	{
		content='<b>No Data Found</b>';
		document.getElementById(htmltag).innerHTML = content;
		return;
	}
	var len = j.feed.entry.length;
	var img_title = "";
	if (j.feed.entry[photo_id].media$group.media$title)
	{
		img_title = j.feed.entry[photo_id].media$group.media$title.$t
	}

	//get the dimensions of the photo we're grabbing; if it's smaller than our max width, there's no need to scale it up.
	var img_width = j.feed.entry[photo_id].media$group.media$content[0].width;
	var img_height = j.feed.entry[photo_id].media$group.media$content[0].height;
	var img_base = j.feed.entry[photo_id].media$group.media$content[0].url;
	var my_galleryname = j.feed.title.$t;

	content ="<div align='center'>";
	content+="<table border='0'>";
	content+="<tr><td valign='top' align='center'>";
	//the navigation panel: back, home, and next.
	content +="<table border=0><tr valign=top><td>";
	if (photo_id>0)
	{
		var prev = 'javascript:DisplayPhoto('+(photo_id-1)+',"'+htmltag+'",'+albumpage+')';
		content +="<a href='"+prev+"'><img src='"+scriptfolder+"ico_prev.gif' border='0'></a>"
	}
	content +="</td><td> </td><td>";
	content +="<a href='javascript:DisplayAlbum(\""+htmltag+"\","+albumpage+")'>" + my_galleryname + "</a>";
	content +="</td><td> </td><td>";
	if (photo_id<(len-1))
	{
	    var next = 'javascript:DisplayPhoto('+(photo_id+1)+',"'+htmltag+'",'+albumpage+')';
		content +="<a href='"+next+"'><img src='"+scriptfolder+"ico_next.gif' border='0'></a>";
	}
	content +="</td></tr></table><br />";
	var link = j.feed.entry[photo_id].id.$t;
	var matchPos1 = link.indexOf("picasa");
	if(matchPos1 != -1)
	{
		if (img_width < photosize)
		{ 
			display_width = img_width; //don't scale up photos that are narrower than our max width; disable this to set all photos to max width
		}
		content +="<div align='center'><img id='picture' src='"+img_base+"?imgmax="+photosize+"'/></div>";
	}
	else
	{
		if ( img_width > photosize)
		{
			content +="<div align='center'><img id='picture' src='"+img_base+"' width='"+photosize+"'/></div>";
		}
		else
		{
			content +="<div align='center'><img id='picture' src='"+img_base+"'/></div>";
		}
	}
	if (j.feed.entry[photo_id].media$group.media$description)
	{
		img_title =j.feed.entry[photo_id].media$group.media$description.$t
	}
	content +="<br><div style='margin-left:2px'>"+img_title+"</div></td></tr></table></div>";
	document.getElementById(htmltag).innerHTML = content;
}

function DisplayAlbum(htmltag,albumpage)
{
	// Parsing RSS
	var j = g_JSONFeedArray[htmltag];
	if (j==undefined)
	{
		content='<b>No Data Found</b>';
		document.getElementById(htmltag).innerHTML = content;
		return;
	}	
	var title = j.feed.title.$t;
	var link = '';
	if (j.feed.link[1])
	{
		link =j.feed.link[1].href;
	}
	else if (j.feed.link[0])
	{
		link =j.feed.link[0].href;
	}
	var album_date = j.feed.updated.$t;
	var desc= j.feed.subtitle.$t;
	var id = j.feed.id.$t;
	var len = j.feed.entry.length;
		
	var item_plural = "s";
	if (len == "1") { item_plural = ""; }
	
	content = "<div align='center'><table border=0>";
	content+= "<tr><td colspan='"+cols+"'>";
	if (display_breadcrumbs)
	{
		content+= "<a class='standard' href=' '><<< Albums</a> &gt; "+ title +"<br/>";
	}
	content+= "<div style='margin-left:3px'><h4><a href='"+link+"'>"+ title +"</a></h4></div>";
	content+= "<div style='margin-left:3px'><i>"+ len +" photo"+item_plural+", "+album_date+"</i></div>";
	content+= "</td></tr>";
	//create paging navigation
	var pageCount = ((len-1)/maxresults);
	
	var navRow = "<tr><td colspan='"+cols+"'>";
	
	var StartItem=albumpage*maxresults;
	if (StartItem>len)
	{
		albumpage=0;
		StartItem=0;
	}
	var i;
	for(i=0;i<=pageCount;i++)
	{
		if(albumpage == i)
		{
			navRow += "<b>["+(i+1)+"]</b> ";
		}
		else
		{
		    navRow += "<a href='javascript:DisplayAlbum(\""+htmltag+"\","+i+")'>"+(i+1)+"</a> ";
		};
	};
	navRow += "</td></tr>"
	content += navRow; 
	
	var EndItem =(albumpage+1)*maxresults;
	if (EndItem>len) EndItem=len;
	var PhotoCount=0;
	for(i=StartItem;i<EndItem;i++)
	{
		var img_base, img_title;
		if (j.feed.entry[i].media$group.media$thumbnail[1])
		{
			img_base = j.feed.entry[i].media$group.media$thumbnail[1].url;
		}
		else
		{
			img_base = j.feed.entry[i].media$group.media$thumbnail[0].url;
		}
		
		if (j.feed.entry[i].media$group.media$description)
		{
			img_title =j.feed.entry[i].media$group.media$description.$t
		}
		else
		{
			if (j.feed.entry[i].media$group.media$title)
			{
				img_title = j.feed.entry[i].media$group.media$title.$t
			}
		}    
		content += "<td valign=top><div align='center'>";
		content += "<a href='javascript:DisplayPhoto("+i+",\""+htmltag+"\","+albumpage+");'>"
		content += "<img src='"+img_base+"'/>";
		content += "</a><br/>";
		content += "<small>"+img_title+"</small>";
		content += "</div></td>";
		if (PhotoCount % cols == (cols-1))
		{
			content += "</tr><tr><td colspan="+cols+"><hr size='1'/></td></tr><tr>";
		}
		PhotoCount++;
	}
	content += "</tr>";
	content += navRow; 
	content += "</table></div>";
	// Display the result
	document.getElementById(htmltag).innerHTML = content;
}